DECLARE SUB LoadMap ()
DECLARE SUB LoadScreen ()
DECLARE SUB LoadGraphics ()
DECLARE SUB LoadVariables ()
DECLARE SUB DrawEnemy ()
DECLARE SUB DrawStats ()
DECLARE SUB DrawPlayer ()
DECLARE SUB DrawMap (sX!, sY!, eX!, eY!)
DECLARE SUB DrawImage (sX!, sY!, eX!, eY!, dZ!)
DECLARE SUB CheckTime ()
DECLARE SUB CheckPlayer ()
DECLARE SUB EnemyMove ()
DECLARE SUB PlayerMove ()
DECLARE SUB WinGame ()
DECLARE SUB GameLoop ()
DECLARE SUB GameOver ()
DECLARE SUB GameMenu ()
DECLARE SUB GamePause ()

DIM SHARED playerForward(200), enemyForward(200)
DIM SHARED playerBackward(200), enemyBackward(200)
DIM SHARED playerLeft(200), enemyLeft(200)
DIM SHARED playerRight(200), enemyRight(200)
DIM SHARED arrowForward(200), arrowBackward(200)
DIM SHARED arrowLeft(200), arrowRight(200)
DIM SHARED fueltank(200), rock(200), mud(200), spin(200)
DIM SHARED mapData(19, 19)

COMMON SHARED playerX, playerY, playerZ, playerSpeed, playerClock!
COMMON SHARED playerLives, playerRotation
COMMON SHARED enemyX, enemyY, enemyZ, enemySpeed, enemyClock!
COMMON SHARED gameClock, counters, slowDown, difficulty, background

GameMenu                         'modify ME!
LoadGraphics
LoadScreen
LoadMap
LoadVariables
GameLoop

UpdateClock:
 gameClock = gameClock - 1
RETURN

PlayerImage:
DATA 2,2,2,0,0,0,0,2,2,2
DATA 0,0,0,0,9,9,0,0,0,0
DATA 2,0,1,0,9,9,0,1,0,2
DATA 2,0,0,0,9,9,0,0,0,2
DATA 0,1,0,9,9,9,9,0,1,0
DATA 2,0,0,9,9,9,9,0,0,2
DATA 2,0,1,0,9,9,0,1,0,2
DATA 0,1,1,0,0,0,0,1,1,0
DATA 2,0,0,2,2,2,2,0,0,2
DATA 2,2,2,2,2,2,2,2,2,2

EnemyImage:
DATA 2,2,2,0,0,0,0,2,2,2
DATA 0,0,0,0,12,12,0,0,0,0
DATA 2,0,4,0,12,12,0,4,0,2
DATA 2,0,0,0,12,12,0,0,0,2
DATA 0,4,0,12,12,12,12,0,4,0
DATA 2,0,0,12,12,12,12,0,0,2
DATA 2,0,4,0,12,12,0,4,0,2
DATA 0,4,4,0,0,0,0,4,4,0
DATA 2,0,0,2,2,2,2,0,0,2
DATA 2,2,2,2,2,2,2,2,2,2

FuelImage:
DATA 2,2,2,2,2,8,8,8,2,2
DATA 2,2,2,2,8,7,7,8,2,2
DATA 2,2,2,2,8,7,8,2,2,2
DATA 2,2,0,8,7,7,8,2,2,2
DATA 2,0,7,8,8,8,8,0,2,2
DATA 2,0,7,12,7,12,7,0,2,2
DATA 2,0,7,7,12,7,7,0,2,2
DATA 2,0,7,12,7,12,7,0,2,2
DATA 2,2,0,0,0,0,0,2,2,2
DATA 2,2,2,2,2,2,2,2,2,2

RockImage:
DATA 2,2,2,2,2,2,2,2,2,2
DATA 2,2,0,0,0,2,2,2,2,2
DATA 2,0,8,8,7,0,0,2,2,2
DATA 0,8,7,8,7,7,15,0,2,2
DATA 0,8,8,7,7,7,15,15,0,2
DATA 0,8,8,7,8,7,7,7,0,2
DATA 2,0,8,8,7,7,7,7,0,2
DATA 2,0,8,8,8,8,0,0,2,2
DATA 2,2,0,0,0,0,2,2,2,2
DATA 2,2,2,2,2,2,2,2,2,2

MudImage:
DATA 2,2,2,0,0,2,2,0,0,0
DATA 2,0,0,6,6,0,0,8,0,2
DATA 2,0,6,0,6,8,6,0,2,2
DATA 2,2,0,6,8,8,8,8,0,2
DATA 2,0,6,6,8,8,8,8,8,0
DATA 2,0,6,6,8,8,6,6,8,0
DATA 2,2,0,6,6,6,0,0,8,0
DATA 2,2,2,0,6,0,2,2,0,0
DATA 2,2,2,2,0,2,2,2,2,0
DATA 2,2,2,2,2,2,2,2,2,2

ArrowImage:
DATA 2,2,2,2,2,2,2,2,2,2
DATA 2,0,0,0,0,0,0,0,0,2
DATA 2,0,15,15,12,12,15,15,0,2
DATA 2,0,15,12,12,12,12,15,0,2
DATA 2,0,12,12,12,12,12,12,0,2
DATA 2,0,15,15,12,12,15,15,0,2
DATA 2,0,15,15,12,12,15,15,0,2
DATA 2,0,15,15,12,12,15,15,0,2
DATA 2,0,0,0,0,0,0,0,0,2
DATA 2,2,2,2,2,2,2,2,2,2

SpinImage:
DATA 2,2,2,2,2,2,2,2,2,2
DATA 2,0,0,0,0,0,0,0,0,2
DATA 2,0,15,1,1,1,15,15,0,2
DATA 2,0,1,9,9,9,1,15,0,2
DATA 2,0,1,9,1,1,9,1,0,2
DATA 2,0,1,9,1,1,9,15,0,2
DATA 2,0,1,9,9,9,1,15,0,2
DATA 2,0,15,1,1,1,15,15,0,2
DATA 2,0,0,0,0,0,0,0,0,2
DATA 2,2,2,2,2,2,2,2,2,2

SUB CheckPlayer
IF mapData(playerX, playerY) = -1 THEN
  counters = counters - 1
  gameClock = gameClock + 5
  mapData(playerX, playerY) = 0
END IF

IF mapData(playerX, playerY) = -2 THEN slowDown = 1 ELSE slowDown = 0
IF mapData(playerX, playerY) = -3 THEN playerZ = 6
IF mapData(playerX, playerY) = -4 THEN playerZ = 4
IF mapData(playerX, playerY) = -5 THEN playerZ = 2
IF mapData(playerX, playerY) = -6 THEN playerZ = 8
IF mapData(playerX, playerY) = -7 THEN playerRotation = -playerRotation

IF counters = 0 THEN
 DrawStats
 WinGame
END IF
END SUB

SUB CheckTime
IF gameClock <= 0 THEN
  IF playerLives = 0 THEN
    GameOver
   ELSE
    TIMER OFF
    playerLives = playerLives - 1
    gameClock = 15
    LoadVariables
    TIMER ON
  END IF
END IF
END SUB

SUB DrawEnemy
eXCoord = (enemyX + 2) * 20
eYCoord = (enemyY + 2) * 20
IF enemyZ = 2 THEN PUT (eXCoord, eYCoord), enemyBackward, PSET
IF enemyZ = 4 THEN PUT (eXCoord, eYCoord), enemyLeft, PSET
IF enemyZ = 6 THEN PUT (eXCoord, eYCoord), enemyRight, PSET
IF enemyZ = 8 THEN PUT (eXCoord, eYCoord), enemyForward, PSET
END SUB

SUB DrawImage (sX, sY, eX, eY, dZ)
 IF dZ = 0 THEN
  FOR pY = sY TO eY
    FOR pX = sX TO eX
     READ pC
     LINE (ABS(pX) * 2, ABS(pY) * 2)-((ABS(pX) * 2) + 2, (ABS(pY) * 2) + 2), pC, BF
    NEXT pX
  NEXT pY
  ELSE
    FOR pX = sX TO eX
     FOR pY = sY TO eY
      READ pC
      LINE (ABS(pX) * 2, ABS(pY) * 2)-((ABS(pX) * 2) + 2, (ABS(pY) * 2) + 2), pC, BF
     NEXT pY
    NEXT pX
 END IF
END SUB

SUB DrawMap (sX, sY, eX, eY)
FOR dY = sY + 2 TO eY + 2
  FOR dX = sX + 2 TO eX + 2
    IF mapData(dX - 2, dY - 2) = -7 THEN PUT (dX * 20, dY * 20), spin, PSET
    IF mapData(dX - 2, dY - 2) = -6 THEN PUT (dX * 20, dY * 20), arrowForward, PSET
    IF mapData(dX - 2, dY - 2) = -5 THEN PUT (dX * 20, dY * 20), arrowBackward, PSET
    IF mapData(dX - 2, dY - 2) = -4 THEN PUT (dX * 20, dY * 20), arrowLeft, PSET
    IF mapData(dX - 2, dY - 2) = -3 THEN PUT (dX * 20, dY * 20), arrowRight, PSET
    IF mapData(dX - 2, dY - 2) = -2 THEN PUT (dX * 20, dY * 20), mud, PSET
    IF mapData(dX - 2, dY - 2) = -1 THEN PUT (dX * 20, dY * 20), fueltank, PSET
    IF mapData(dX - 2, dY - 2) = 0 THEN LINE (dX * 20, dY * 20)-((dX * 20) + 19, (dY * 20) + 19), 2, BF
    IF mapData(dX - 2, dY - 2) = 1 THEN PUT (dX * 20, dY * 20), rock, PSET
  NEXT dX
NEXT dY
END SUB

SUB DrawPlayer
pXCoord = (playerX + 2) * 20
pYCoord = (playerY + 2) * 20
IF playerZ = 2 THEN PUT (pXCoord, pYCoord), playerBackward, PSET
IF playerZ = 4 THEN PUT (pXCoord, pYCoord), playerLeft, PSET
IF playerZ = 6 THEN PUT (pXCoord, pYCoord), playerRight, PSET
IF playerZ = 8 THEN PUT (pXCoord, pYCoord), playerForward, PSET
END SUB

SUB DrawStats

LOCATE 2, 65: PRINT "STATUS"
COLOR 13
LOCATE 4, 62: PRINT "Fuel Left:"; counters

COLOR 14
LOCATE 6, 62: PRINT "Lives Left:"; playerLives

COLOR 15
LOCATE 8, 62: PRINT "x:"; playerX
LOCATE 9, 62: PRINT "y:"; playerY
LOCATE 10, 62: PRINT "speed:"; playerSpeed
LOCATE 11, 62: PRINT "rotation:"; playerRotation

LOCATE 2, 30: PRINT USING "***#"; gameClock
END SUB

SUB EnemyMove
DrawMap enemyX, enemyY, enemyX, enemyY
checkX = enemyX - playerX
checkY = enemyY - playerY

IF ABS(checkX) > ABS(checkY) THEN
  IF checkX < 0 AND enemyX < 19 THEN
   IF mapData(enemyX + 1, enemyY) < 1 THEN
    enemyZ = 6
    enemyX = enemyX + 1
   END IF
   ELSEIF enemyX > 0 THEN
   IF mapData(enemyX - 1, enemyY) < 1 THEN
    enemyZ = 4
    enemyX = enemyX - 1
   END IF
  END IF
 ELSE
  IF checkY < 0 AND enemyY < 19 THEN
   IF mapData(enemyX, enemyY + 1) < 1 THEN
    enemyZ = 2
    enemyY = enemyY + 1
   END IF
   ELSEIF enemyY > 0 THEN
   IF mapData(enemyX, enemyY - 1) < 1 THEN
    enemyZ = 8
    enemyY = enemyY - 1
   END IF
  END IF
END IF

DrawEnemy
IF playerX = enemyX AND playerY = enemyY THEN gameClock = gameClock - 5

enemyClock! = TIMER
END SUB

SUB GameLoop
TIMER ON
ON TIMER(1) GOSUB UpdateClock
playerClock! = TIMER
enemyClock! = TIMER
DO
 DO
   DrawStats
   IF playerClock! + playerSpeed + slowDown < TIMER THEN PlayerMove
   IF enemyClock! + enemySpeed < TIMER THEN EnemyMove
   MOVE$ = INKEY$
   CheckTime
 LOOP UNTIL MOVE$ <> ""
 IF gameClock = 0 THEN GameOver
 IF MOVE$ = " " THEN
  IF playerRotation = 90 THEN
    IF playerZ = 8 THEN
      playerZ = 6
     ELSEIF playerZ = 6 THEN playerZ = 2
     ELSEIF playerZ = 2 THEN playerZ = 4
     ELSEIF playerZ = 4 THEN playerZ = 8
    END IF
   ELSE
    IF playerZ = 8 THEN
      playerZ = 4
     ELSEIF playerZ = 6 THEN playerZ = 8
     ELSEIF playerZ = 2 THEN playerZ = 6
     ELSEIF playerZ = 4 THEN playerZ = 2
    END IF
  END IF
 END IF
 IF MOVE$ = CHR$(27) THEN
  GamePause
 END IF
LOOP
END SUB

SUB GameMenu
enemySpeed = .3         'higher = slower
difficulty = 50         '100 = easy      50 = tough      30 = impossible

playerLives = 1         'if you die. . .
playerSpeed = .1        'higher = slower
playerRotation = 90     'rotate clockwise, -90 for counterclockwise

gameClock = 15          'starting time
background = 8          'general background color
END SUB

SUB GameOver
TIMER OFF
LINE (190, 200)-(295, 230), 0, BF
LINE (190, 200)-(295, 230), 15, B
LOCATE 14, 27: PRINT "Game Over"
GamePause
SYSTEM
END SUB

SUB GamePause
 DO
  MOVE$ = INKEY$
 LOOP UNTIL MOVE$ <> ""
 IF MOVE$ = CHR$(27) THEN GameOver
END SUB

SUB LoadGraphics
SCREEN 12
WIDTH 80, 30

  RESTORE PlayerImage
  DrawImage 0, 0, 9, 9, 0
  GET (0, 0)-(19, 19), playerForward
  RESTORE PlayerImage
  DrawImage 0, -9, 9, 0, 0
  GET (0, 0)-(19, 19), playerBackward
  RESTORE PlayerImage
  DrawImage 0, 0, 9, 9, 1
  GET (0, 0)-(19, 19), playerLeft
  RESTORE PlayerImage
  DrawImage -9, 0, 0, 9, 1
  GET (0, 0)-(19, 19), playerRight

  RESTORE EnemyImage
  DrawImage 0, 0, 9, 9, 0
  GET (0, 0)-(19, 19), enemyForward
  RESTORE EnemyImage
  DrawImage 0, -9, 9, 0, 0
  GET (0, 0)-(19, 19), enemyBackward
  RESTORE EnemyImage
  DrawImage 0, 0, 9, 9, 1
  GET (0, 0)-(19, 19), enemyLeft
  RESTORE EnemyImage
  DrawImage -9, 0, 0, 9, 1
  GET (0, 0)-(19, 19), enemyRight

  RESTORE FuelImage
  DrawImage 0, 0, 9, 9, 0
  GET (0, 0)-(19, 19), fueltank
  RESTORE RockImage
  DrawImage 0, 0, 9, 9, 0
  GET (0, 0)-(19, 19), rock
  RESTORE MudImage
  DrawImage 0, 0, 9, 9, 0
  GET (0, 0)-(19, 19), mud
  RESTORE SpinImage
  DrawImage 0, 0, 9, 9, 0
  GET (0, 0)-(19, 19), spin

  RESTORE ArrowImage
  DrawImage 0, 0, 9, 9, 0
  GET (0, 0)-(19, 19), arrowForward
  RESTORE ArrowImage
  DrawImage 0, -9, 9, 0, 0
  GET (0, 0)-(19, 19), arrowBackward
  RESTORE ArrowImage
  DrawImage 0, 0, 9, 9, 1
  GET (0, 0)-(19, 19), arrowLeft
  RESTORE ArrowImage
  DrawImage -9, 0, 0, 9, 1
  GET (0, 0)-(19, 19), arrowRight
  
  PAINT (0, 0), background
END SUB

SUB LoadMap
RANDOMIZE TIMER
FOR mY = 0 TO 19
 FOR mX = 0 TO 19
  IF INT(RND * difficulty) + 1 = 14 THEN mapData(mX, mY) = 1    'rock
  IF INT(RND * difficulty * 2) + 1 = 15 THEN mapData(mX, mY) = -2 'mud
  IF INT(RND * difficulty) + 1 = 16 THEN mapData(mX, mY) = -3   'arrow
  IF INT(RND * difficulty) + 1 = 17 THEN mapData(mX, mY) = -4   'arrow
  IF INT(RND * difficulty) + 1 = 18 THEN mapData(mX, mY) = -5 'arrow
  IF INT(RND * difficulty) + 1 = 19 THEN mapData(mX, mY) = -6 'arrow
  IF INT(RND * (difficulty * 3)) + 1 = 20 THEN mapData(mX, mY) = -7 'arrow
  IF INT(RND * 30) + 1 = 3 THEN
    mapData(mX, mY) = -1
    counters = counters + 1
  END IF
 NEXT mX
NEXT mY
END SUB

SUB LoadScreen
LINE (40, 15)-(440, 30), 15, BF
LINE (200, 10)-(280, 35), 0, BF
LINE (200, 10)-(280, 35), 15, B

LINE (10, 40)-(30, 60), 15, BF
LINE (10, 80)-(30, 440), 15, BF

LINE (480, 10)-(600, 180), 0, BF
LINE (480, 10)-(600, 180), 15, B

LINE (480, 205)-(600, 260), 0, BF
LINE (480, 205)-(600, 260), 15, B
LOCATE 14, 62: PRINT "SPACE rotate"
LOCATE 15, 62: PRINT "ESC pause"
LOCATE 16, 62: PRINT "ESCx2 quit"

LINE (38, 38)-(441, 441), 15, B
END SUB

SUB LoadVariables
playerX = 0
playerY = 19
playerZ = 8

enemyX = 19
enemyY = 0
enemyZ = 2

animation! = TIMER

LINE (190, 200)-(290, 230), 0, BF
LINE (190, 200)-(290, 230), 15, B
LOCATE 14, 28: PRINT "READY?"
GamePause
DrawMap 0, 0, 19, 19
DrawPlayer
DrawEnemy
END SUB

SUB PlayerMove
DrawMap playerX, playerY, playerX, playerY
IF playerZ = 2 AND playerY < 19 THEN
 IF mapData(playerX, playerY + 1) < 1 THEN playerY = playerY + 1
END IF
IF playerZ = 4 AND playerX > 0 THEN
 IF mapData(playerX - 1, playerY) < 1 THEN playerX = playerX - 1
END IF
IF playerZ = 6 AND playerX < 19 THEN
 IF mapData(playerX + 1, playerY) < 1 THEN playerX = playerX + 1
END IF
IF playerZ = 8 AND playerY > 0 THEN
 IF mapData(playerX, playerY - 1) < 1 THEN playerY = playerY - 1
END IF

DrawPlayer
CheckPlayer

playerClock! = TIMER
END SUB

SUB WinGame
TIMER OFF
LINE (190, 200)-(295, 230), 0, BF
LINE (190, 200)-(295, 230), 15, B
LOCATE 14, 27: PRINT "YOU WIN!!"
GamePause
SYSTEM
END SUB

